#!/bin/sh
# Convert the current repo to something that can be merged to mozilla-central.
# This script needs to be run from the top level directory of the repo.

# If the current directory is called 'fx-sync', the output repository
# will be in 'fx-sync.converted'.
outrepo=`basename $PWD`.converted
hg convert --filemap tools/convert.map . ../$outrepo

# Strip the extraneous commit for tags
cd ../$outrepo
hg strip tip

# Remove the last line from the shamap since that changeset was stripped.
sed '$d' .hg/shamap > .hg/shamap.new
mv .hg/shamap.new .hg/shamap
