var Ci = Components.interfaces;
var Cc = Components.classes;
var Cr = Components.results;

let Change = {
  get _stringBundle() {
    let stringBundle = document.getElementById("weaveStringBundle");
    this.__defineGetter__("_stringBundle", function() { return stringBundle; });
    return this._stringBundle;
  },

  get _dialog() {
    delete this._dialog;
    return this._dialog = document.getElementById("change-dialog");
  },

  get _dialogType() {
    delete this._dialogType;
    return this._dialogType = window.arguments[0];
  },

  get _title() {
    return document.getElementById("change-dialog").getAttribute("title");
  },

  set _title(val) {
    document.getElementById("change-dialog").setAttribute("title", val);
  },

  get _status() {
    delete this._status;
    return this._status = document.getElementById("status");
  },

  get _statusIcon() {
    delete this._statusIcon;
    return this._statusIcon = document.getElementById("statusIcon");
  },

  get _statusRow() {
    delete this._statusRow;
    return this._statusRow = document.getElementById("statusRow");
  },

  get _firstBox() {
    delete this._firstBox;
    return this._firstBox = document.getElementById("textBox1");
  },

  get _secondBox() {
    delete this._secondBox;
    return this._secondBox = document.getElementById("textBox2");
  },

  get _passphraseBox() {
    delete this._passphraseBox;
    return this._passphraseBox = document.getElementById("passphraseBox");
  },

  get _passphraseStrengthRow() {
    delete this._passphraseStrengthRow;
    return this._passphraseStrengthRow = document.getElementById("passphraseStrengthRow");
  },

  get _currentPasswordInvalid() {
    return Weave.Status.login == Weave.LOGIN_FAILED_LOGIN_REJECTED;
  },

  get _updatingPassphrase() {
    return this._dialogType == "UpdatePassphrase";
  },

  onLoad: function Change_onLoad() {
    /* Load labels */
    let introText = document.getElementById("introText");
    let introText2 = document.getElementById("introText2");
    let warningText = document.getElementById("warningText");

    switch (this._dialogType) {
      case "UpdatePassphrase":
      case "ResetPassphrase":
        document.getElementById("textBox1Row").hidden = true;
        document.getElementById("textBox2Row").hidden = true;
        let passphraseLabel = document.getElementById("passphraseLabel");
        passphraseLabel.value = this._str("new.synckey.label");
        this._dialog.setAttribute(
          "ondialogaccept",
          "return Change.doChangePassphrase();"
        );

        if (this._updatingPassphrase) {
          document.getElementById("passphraseBackupButtons").hidden = true;
          document.getElementById("generatePassphraseButton").hidden = true;
          this._title = this._str("new.synckey.title");
          introText.innerHTML = this._str("new.synckey.introText");
          this._dialog.getButton("accept")
              .setAttribute("label", this._str("new.synckey.acceptButton"));
        }
        else {
          let pp = Weave.Service.passphrase;
          if (pp.length == 20)
            pp = Weave.Utils.hyphenatePassphrase(pp);
          document.getElementById("passphraseBox").value = pp;
          this._title = this._str("change.synckey.title");
          introText.innerHTML = this._str("change.synckey.introText");
          introText2.innerHTML = this._str("change.synckey.introText2");
          warningText.innerHTML = this._str("change.synckey.warningText");
          this._dialog.getButton("accept")
              .setAttribute("label", this._str("change.synckey.acceptButton"));
        }
        break;
      case "ChangePassword":
        document.getElementById("passphraseRow").hidden = true;
        document.getElementById("passphraseBackupButtons").hidden = true;
        let box1label = document.getElementById("textBox1Label");
        let box2label = document.getElementById("textBox2Label");
        box1label.value = this._str("new.password.label");
        this._dialog.setAttribute(
          "ondialogaccept",
          "return Change.doChangePassword();"
        );

        if (this._currentPasswordInvalid) {
          this._title = this._str("new.password.title");
          introText.innerHTML = this._str("new.password.introText");
          this._dialog.getButton("accept")
              .setAttribute("label", this._str("new.password.acceptButton"));
          document.getElementById("textBox2Row").hidden = true;
        }
        else {
          this._title = this._str("change.password.title");
          box2label.value = this._str("new.password.confirm");
          introText.innerHTML = this._str("change.password2.introText");
          warningText.innerHTML = this._str("change.password.warningText");
          this._dialog.getButton("accept")
              .setAttribute("label", this._str("change.password.acceptButton"));
        }
        break;
    }
  },

  _clearStatus: function _clearStatus() {
    this._status.value = "";
    this._statusIcon.removeAttribute("status");
  },

  _updateStatus: function Change__updateStatus(str, state) {
     this._updateStatusWithString(this._str(str), state);
  },
  
  _updateStatusWithString: function Change__updateStatusWithString(string, state) {
    this._statusRow.hidden = false;
    this._passphraseStrengthRow.hidden = true;
    this._status.value = string;
    this._statusIcon.setAttribute("status", state);

    let error = state == "error";
    this._dialog.getButton("cancel").setAttribute("disabled", !error);
    this._dialog.getButton("accept").setAttribute("disabled", !error);
    document.getElementById("printSyncKeyButton").disabled = !error;
    document.getElementById("saveSyncKeyButton").disabled = !error;

    if (state == "success")
      window.setTimeout(window.close, 1500);
  },

  doGeneratePassphrase: function () {
    let passphrase = Weave.Utils.generatePassphrase();
    let el = document.getElementById("passphraseBox");
    el.value = Weave.Utils.hyphenatePassphrase(passphrase);
    this._passphraseStrengthRow.hidden = true;
    this._dialog.getButton("accept").disabled = false;
  },

  doChangePassphrase: function Change_doChangePassphrase() {
    let pp = Weave.Utils.normalizePassphrase(this._passphraseBox.value);
    if (this._updatingPassphrase) {
      Weave.Service.passphrase = pp;
      if (Weave.Service.login()) {
        this._updateStatus("change.synckey.success", "success");
        Weave.Service.persistLogin();
      }
      else
        this._updateStatus("new.synckey.status.incorrect", "error");
    }
    else {
      this._updateStatus("change.synckey.label", "active");

      if (Weave.Service.changePassphrase(pp))
        this._updateStatus("change.synckey.success", "success");
      else
        this._updateStatus("change.synckey.error", "error");
    }

    return false;
  },

  doChangePassword: function Change_doChangePassword() {
    if (this._currentPasswordInvalid) {
      Weave.Service.password = this._firstBox.value;
      if (Weave.Service.login()) {
        this._updateStatus("change.password.status.success", "success");
        Weave.Service.persistLogin();
      }
      else
        this._updateStatus("new.password.status.incorrect", "error");
    }
    else {
      this._updateStatus("change.password.status.active", "active");

      if (Weave.Service.changePassword(this._firstBox.value))
        this._updateStatus("change.password.status.success", "success");
      else
        this._updateStatus("change.password.status.error", "error");
    }

    return false;
  },

  validate: function () {
    let valid = false;
    let errorString = "";

    if (this._dialogType == "ChangePassword") {
      if (this._currentPasswordInvalid)
        [valid, errorString] = gWeaveCommon.validatePassword(this._firstBox);
      else
        [valid, errorString] = gWeaveCommon.validatePassword(this._firstBox, this._secondBox);
    }
    else {
      if (this._updatingPassphrase) {
        [valid, errorString] = gWeaveCommon.validatePassphrase(this._passphraseBox);
      } else {
        [valid, errorString] = gWeaveCommon.validatePassphrase(this._passphraseBox, true);
        if (valid)
          this.displayPassphraseStrength();
      }
    }

    if (errorString == "")
      this._clearStatus();
    else
      this._updateStatusWithString(errorString, "error");

    this._statusRow.hidden = valid;
    this._dialog.getButton("accept").disabled = !valid;
  },

  displayPassphraseStrength: function () {
    let bits = Weave.Utils.passphraseStrength(this._passphraseBox.value);
    let meter = document.getElementById("passphraseStrength");
    meter.value = bits;
    // The generated 20 character passphrase has an entropy of 94 bits
    // which we consider "strong".
    if (bits > 94)
      meter.className = "strong";
    else if (bits > 47)
      meter.className = "medium";
    else
      meter.className = "";
    this._passphraseStrengthRow.hidden = false;
  },

  _str: function Change__string(str) {
    return this._stringBundle.getString(str);
  }
};
